{** Project Test8087 Mainform.
 *
 *  @author (c) 2001-2003 by fixxion freeware, Hamburg
 *}
unit Test8087CWMainform;
//==============================================================================

//==============================================================================
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons,
  FloatCtrl;
//==============================================================================

//------------------------------------------------------------------------------
type
  TFormTest8087CW = class(TForm)
    CheckboxExcInvalidOperation: TCheckBox;
    CheckBoxExcDenormalizedOperand: TCheckBox;
    CheckBoxExcZeroDivide: TCheckBox;
    CheckBoxExcOverflow: TCheckBox;
    CheckBoxExcUnderflow: TCheckBox;
    CheckBoxExcPrecision: TCheckBox;
    CheckBoxExcInterrupt: TCheckBox;
    CheckBoxPrecisionControlLow: TCheckBox;
    CheckBoxPrecisionControlHigh: TCheckBox;
    CheckBoxRoundControlLow: TCheckBox;
    CheckBoxRoundControlHigh: TCheckBox;
    CheckBoxInfinityControl: TCheckBox;
    LabelCWBinaryDefault: TLabel;
    LabelControlWordHex: TLabel;
    LabelControlWordTitle: TLabel;
    Bevel4: TBevel;
    Bevel5: TBevel;
    Bevel6: TBevel;
    Bevel7: TBevel;
    Bevel8: TBevel;
    Bevel9: TBevel;
    Bevel11: TBevel;
    Bevel12: TBevel;
    Bevel13: TBevel;
    Bevel14: TBevel;
    Bevel15: TBevel;
    Bevel16: TBevel;
    Bevel17: TBevel;
    Bevel18: TBevel;
    Bevel19: TBevel;
    Bevel20: TBevel;
    Bevel21: TBevel;
    Bevel22: TBevel;
    Bevel24: TBevel;
    Bevel25: TBevel;
    Bevel26: TBevel;
    Bevel27: TBevel;
    Bevel28: TBevel;
    Bevel1: TBevel;
    LabelPrecisionControlValue: TLabel;
    LabelRoundControlValue: TLabel;
    LabelInfinityControlValue: TLabel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    PanelBottom: TPanel;
    BitBtnExit: TBitBtn;
    PanelStatus: TPanel;
    LabelCWBinaryStandard: TLabel;
    LabelCWBinaryStandardTitle: TLabel;
    LabelCWBinaryDefaultTitle: TLabel;
    BitBtnZeroDivide: TBitBtn;
    BitBtnOverflow: TBitBtn;
    BitBtnUnderflow: TBitBtn;
    BitBtnTestRound: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CheckboxControlWordClick(Sender: TObject);
    procedure BitBtnExitClick(Sender: TObject);
    procedure BitBtnInvalidOperationClick(Sender: TObject);
    procedure BitBtnDenormalizedOperandClick(Sender: TObject);
    procedure BitBtnZeroDivideClick(Sender: TObject);
    procedure BitBtnOverflowClick(Sender: TObject);
    procedure BitBtnUnderflowClick(Sender: TObject);
    procedure BitBtnPrecisionClick(Sender: TObject);
    procedure BitBtnTestRoundClick(Sender: TObject);
  private
    fUpdating: boolean;
    fFloatControl: TFloatControlVerbose;
    procedure InitializeControls;
    procedure ShowHint(Sender: TObject);
    procedure UpdateControls;
    procedure UpdateLabels;
  end;

//------------------------------------------------------------------------------
var
  FormTest8087CW: TFormTest8087CW;

//==============================================================================
implementation
{$R *.dfm}
uses
  Test8087CWRoundInfo;
//==============================================================================

//----------------------------------------------------------------------------
//---- Strings
//----------------------------------------------------------------------------
function IntToBinaryStr(
  const aInteger: integer;
  const aDigits: integer = -1): string;
var
  a_CompInt: integer;
  a_BitIndex: integer;
  is_Set: boolean;
begin
  Result := '';
  a_CompInt := 1;
  for a_BitIndex := 1 to 32 do
  begin
    is_Set := ( (aInteger and a_CompInt) <> 0 );
    if is_Set then
      Result := '1' + Result
    else
      Result := '0' + Result;
    a_CompInt := a_CompInt * 2;
  end;
  if ( aDigits <> -1 ) then
    for a_BitIndex := 1 to 32 do
    begin
      if ( Length(Result) <= aDigits ) then
        Break;
      if ( Result[1] = '0' ) then
        Delete(Result, 1, 1)
      else
        Break;
    end;
end; // IntToBinaryStr

//------------------------------------------------------------------------------
const
  S_UNDER_CONSTRUCTION =
    '...under construction...';
  S_INFORMATION =
    'Information';
  S_GENERATE_DENORMALIZEDOP =
    'Generate Denormalized Operation Exception';
  S_GENERATE_OVERFLOW =
    'Generate Overflow Exception';
  S_GENERATE_UNDERFLOW =
    'Generate Underflow Exception';
  S_GENERATE_ZERODIVIDE =
    'Generate Zero Divide Exception';

//------------------------------------------------------------------------------
procedure TFormTest8087CW.FormCreate(Sender: TObject);
begin
  fFloatControl := TFloatControlVerbose.Create;
  InitializeControls;
  fUpdating := FALSE;
  UpdateControls;
  Application.OnHint := ShowHint;
end;

//------------------------------------------------------------------------------
procedure TFormTest8087CW.FormDestroy(Sender: TObject);
begin
  fFloatControl.Free;
end;

//------------------------------------------------------------------------------
procedure TFormTest8087CW.InitializeControls;
var
  i: integer;
  a_Checkbox: TCheckbox;
begin
  for i:=0 to Pred(ComponentCount) do
    if ( Components[i] is TCheckbox ) then
    begin
      a_Checkbox := ( Components[i] as TCheckbox );
      a_Checkbox.Hint := #032 + FLOAT_CONTROL_HINTS[a_Checkbox.Tag];
      a_Checkbox.Font.Color := clBlack;
    end;
  LabelCWBinaryStandard.Caption :=
    IntToBinaryStr(fFloatControl.ControlWord, 16);
end;

//------------------------------------------------------------------------------
procedure TFormTest8087CW.ShowHint(Sender: TObject);
begin
  PanelStatus.Caption := Application.Hint;
end;

//------------------------------------------------------------------------------
procedure TFormTest8087CW.UpdateControls;
var
  i: integer;
  a_Checkbox: TCheckbox;
begin
  fUpdating := TRUE;
  try
    for i:=0 to Pred(ComponentCount) do
      if ( Components[i] is TCheckbox ) then
      begin
        a_Checkbox := ( Components[i] as TCheckbox );
        a_Checkbox.Checked := fFloatControl.ControlWordIsBitSet(a_Checkbox.Tag);
      end;
    UpdateLabels;
  finally
    fUpdating := FALSE;
  end;
end;

//------------------------------------------------------------------------------
procedure TFormTest8087CW.UpdateLabels;
begin
  LabelCWBinaryDefault.Caption :=
    IntToBinaryStr(fFloatControl.ControlWord, 16);
  LabelPrecisionControlValue.Caption :=
    '= ' + fFloatControl.PrecisionControlStr;
  LabelRoundControlValue.Caption :=
    '= ' + fFloatControl.RoundControlStr;
  LabelInfinityControlValue.Caption :=
    '= ' + fFloatControl.InfinityControlStr;
  LabelInfinityControlValue.Hint :=
    ' ' + fFloatControl.InfinityControlHint;
end;

//------------------------------------------------------------------------------
procedure TFormTest8087CW.CheckboxControlWordClick(Sender: TObject);
begin
  if not fUpdating then
  begin
    if ( (Sender as TCheckbox).Font.Color = clBlack ) then
      (Sender as TCheckbox).Font.Color := clBlue
    else
      (Sender as TCheckbox).Font.Color := clBlack;
    fFloatControl.ControlWordSetBit(
      (Sender as TCheckbox).Tag,
      (Sender as TCheckbox).Checked);
    UpdateLabels;
  end;
end;

//------------------------------------------------------------------------------
procedure TFormTest8087CW.BitBtnExitClick(Sender: TObject);
begin
  Close;
end;

//------------------------------------------------------------------------------
procedure TFormTest8087CW.BitBtnInvalidOperationClick(Sender: TObject);
begin
  Application.MessageBox(S_UNDER_CONSTRUCTION, S_INFORMATION, MB_OK);
end;

//------------------------------------------------------------------------------
procedure TFormTest8087CW.BitBtnDenormalizedOperandClick(Sender: TObject);
var
  a_Factor1: extended;
  a_Factor2: extended;
  a_String: string;
begin
  try
    a_Factor1 := 1E4800 * 1E4800;
    a_Factor2 := 1E4800 * 1E4800;
    try
      a_String := Format(
        'No exception:'#10 + '%f * %f = %f',
        [a_Factor1, a_Factor2, a_Factor1 * a_Factor2]);
    except
      a_String := Format(
        'Exception:'#10 + '%f * %f = ####',
        [a_Factor1, a_Factor2]);
      raise;
    end;
  finally
    Application.MessageBox(PChar(a_String), S_GENERATE_DENORMALIZEDOP, MB_OK);
  end;
end;

//------------------------------------------------------------------------------
procedure TFormTest8087CW.BitBtnZeroDivideClick(Sender: TObject);
var
  a_Factor1: extended;
  a_Factor2: extended;
  a_String: string;
begin
  try
    a_Factor1 := 1E4800;
    a_Factor2 := 0;
    try
      a_String := Format(
        'No exception:'#10 + '%g / %g = %g',
        [a_Factor1, a_Factor2, a_Factor1 / a_Factor2]);
    except
      a_String := Format(
        'Exception:'#10 + '%g / %g = ####',
        [a_Factor1, a_Factor2]);
      raise;
    end;
  finally
    Application.MessageBox(PChar(a_String), S_GENERATE_ZERODIVIDE, MB_OK);
  end;
end;

//------------------------------------------------------------------------------
procedure TFormTest8087CW.BitBtnOverflowClick(Sender: TObject);
var
  a_Factor1: extended;
  a_Factor2: extended;
  a_String: string;
begin
  try
    a_Factor1 := 1E4800;
    a_Factor2 := 1E4800;
    try
      a_String := Format(
        'No exception:'#10 + '%f * %f = %f',
        [a_Factor1, a_Factor2, a_Factor1 * a_Factor2]);
    except
      a_String := Format(
        'Exception:'#10 + '%f * %f = ####',
        [a_Factor1, a_Factor2]);
      raise;
    end;
  finally
    Application.MessageBox(PChar(a_String), S_GENERATE_OVERFLOW, MB_OK);
  end;
end;

//------------------------------------------------------------------------------
procedure TFormTest8087CW.BitBtnUnderflowClick(Sender: TObject);
var
  a_Factor1: extended;
  a_Factor2: extended;
  a_Product: extended;
  a_String: string;
begin
  try
    a_Factor1 := 1E-4800;
    a_Factor2 := 1E-4800;
    try
      a_Product := a_Factor1 * a_Factor2;
      a_String := Format(
        'No exception:'#10 + '%f * %f = %f',
        [a_Factor1, a_Factor2, a_Product]);
    except
      a_String := Format(
        'Exception:'#10 + '%f * %f = ####',
        [a_Factor1, a_Factor2]);
      raise;
    end;
  finally
    Application.MessageBox(PChar(a_String), S_GENERATE_UNDERFLOW, MB_OK);
  end;
end;

//------------------------------------------------------------------------------
procedure TFormTest8087CW.BitBtnPrecisionClick(Sender: TObject);
begin
  Application.MessageBox(S_UNDER_CONSTRUCTION, S_INFORMATION, MB_OK);
end;

//------------------------------------------------------------------------------
procedure TFormTest8087CW.BitBtnTestRoundClick(Sender: TObject);
begin
  FormDlgRoundInfo.ShowRoundControl(fFloatControl);
  FormDlgRoundInfo.ShowModal;
end;

end.
